<?php

declare(strict_types=1);
namespace Drupal\confirmation_example\Entity;

use Drupal\confirmation\Entity\Confirmation;
use Drupal\confirmation\Entity\ConfirmationWithEmailInterface;
use Drupal\confirmation\Entity\RequiredEmailFieldTrait;
use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\node\NodeInterface;

class ExampleConfirmationBundle extends Confirmation implements ConfirmationWithEmailInterface {

  use StringTranslationTrait;
  use RequiredEmailFieldTrait;

  const BUNDLE = 'confirmation_example';

  const FieldNode = 'confirmation_example__node';

  public static function bundleFieldDefinitions(EntityTypeInterface $entity_type, $bundle, array $base_field_definitions) {
    $fields = [];
    self::makeEmailFieldRequired($fields, $base_field_definitions);
    return $fields;
  }

  public function getNode(): NodeInterface {
    return $this->get(self::FieldNode)->first()->get('entity')->getValue();
  }

  /**
   * @return $this
   */
  public function setNode(NodeInterface $node) {
    $this->set(self::FieldNode, $node);
    return $this;
  }

  public function getConfirmationQuestion() {
    return $this->t('Confirm publishing of node: %label', ['%label' => $this->getNode()->label()]);
  }

}
